cccccccc program: alfit.f ccccc version: 17 May 2003 ccccccccccccccccccccccc
c Calculates the error-weighted L1 norm of observed and predicted
c coherence functions generated by memcoh.f.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c  Modified by Gareth Armstrong, Dept. Earth Sciences,Uni. Oxford,
c  on 17/2/99 to use the Salford 
c  ftn77 compiler call to COMMand_LINE to read in command line arguments 
c  similar to the f77 compiler call to getarg when being used on the PC
c  Comment or uncomment relevant calls as required.
c  Changed Units numbers to be above 12
c  NOT required to be array size adjustable
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      implicit none
c
c common variables
c
      real*8 cobs(400),cprd(400),el1(400),sdev(400),sdvp(400),
     &       te(400),wvno(400),wvnp(400)
      integer ntot,ntote,ntotp
      common /ERRS  / te,el1,ntote
      common /OCOH  / wvno,cobs,sdev,ntot
      common /PCOH  / wvnp,cprd,sdvp,ntotp
c
c Local variables
c
      character card*50,infile1*20,infile2*20,outfile*20
      real*8 dum(400)
      real*8 elastt,erc1,pi
c
      call getarg(1,infile1)
      call getarg(2,infile2)
      call getarg(3,outfile)
      call getarg(4,card)
c
c-----------------------------------------------------------------------
c  THE NEXT call TO COMMand_LINE PERTAINS TO THE SALFORD FTN77 COMPILER
c  and IS USED ON THE PC INSTEAD OF f77'S call TO getarg
c-----------------------------------------------------------------------
c
c      call COMMand_LINE(card)
c      read(card,*)infile1,infile2,outfile,elastt
c
      read(card,*)elastt
      open(13,file=infile1,status='old')
      rewind(13)
      open(14,file=infile2,status='old')
      rewind(14)
      open(15,file=outfile,status='unknown')
      rewind(15)
      pi=3.14159265358979d0
      call input
      call sortc(wvno,cobs,sdev,ntot)
      call sortc(wvnp,cprd,sdvp,ntotp)
      call resid(erc1)
      ntote=ntote+1
      te(ntote)=elastt
      el1(ntote)=erc1
      call sortc(te,el1,dum,ntote)
      call output
      end
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine input
      implicit none
c
c common variables
c
      real*8 cobs(400),cprd(400),el1(400),sdev(400),sdvp(400),
     &       te(400),wvno(400),wvnp(400)
      integer ntot,ntote,ntotp
      common /ERRS  / te,el1,ntote
      common /OCOH  / wvno,cobs,sdev,ntot
      common /PCOH  / wvnp,cprd,sdvp,ntotp
c
c Local variables
c
      real*8 erc,r1,r2
c
      ntot=0
      do while(.true.)
        read(13,*,end=100)r1,r2,erc
        ntot=ntot+1
        wvno(ntot+1)=r1
        cobs(ntot+1)=r2
        sdev(ntot+1)=erc
      enddo
100   ntotp=0
      do while(.true.)
        read(14,*,end=200)r1,r2,erc
        ntotp=ntotp+1
        wvnp(ntotp+1)=r1
        cprd(ntotp+1)=r2
        sdvp(ntotp+1)=erc
      enddo
200   ntote=0
      do while(.true.)
        read(15,*,end=300)r1,r2
        ntote=ntote+1
        te(ntote)=r1
        el1(ntote)=r2
      enddo
300   return
      end
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine sortc(wvn,coh,sdv,nn)
      implicit none
c
c Dummy arguments
c
      integer nn
      real*8 coh(400),sdv(400),wvn(400)
c
c Local variables
c
      integer i,iclnd,isrtd,j
      real*8 tmp
c
      isrtd=0
      do while(isrtd.ne.1)
        isrtd=1
        do i=1,nn-1
          if(wvn(i).gt.wvn(i+1))then
            tmp=wvn(i)
            wvn(i)=wvn(i+1)
            wvn(i+1)=tmp
            tmp=coh(i)
            coh(i)=coh(i+1)
            coh(i+1)=tmp
            tmp=sdv(i)
            sdv(i)=sdv(i+1)
            sdv(i+1)=tmp
            isrtd=0
          endif
        enddo
      enddo
      iclnd=0
      do while(iclnd.ne.1)
        iclnd=1
        do i=1,nn-1
          if(wvn(i).eq.wvn(i+1).or.wvn(i).eq.0d0)then
            do j=i,nn-1
              wvn(j)=wvn(j+1)
              coh(j)=coh(j+1)
              sdv(j)=sdv(j+1)
            enddo
            wvn(nn)=0d0
            coh(nn)=0d0
            sdv(nn)=0d0
            nn=nn-1
            iclnd=0
          endif
        enddo
      enddo
      return
      end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine resid(erc1)
      implicit none
c
c common variables
c
      real*8 cobs(400),sdev(400),wvno(400)
      integer ntot
      common /OCOH  / wvno,cobs,sdev,ntot
c
c Dummy arguments
c
      real*8 erc1
c
c Local variables
c
      real*8 dabs
      real*8 cflt
      real*8 enm1
      integer i
c
      erc1=0d0
      enm1=0d0
      do i=1,ntot
        if(wvno(i).lt.2d-1)then
          erc1=erc1+dabs(cobs(i)-cflt(wvno(i)))/sdev(i)
          enm1=enm1+1d0/sdev(i)
        endif
      enddo
      erc1=erc1/enm1
      return
      end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine output
      implicit none
c
c common variables
c
      real*8 el1(400),te(400)
      integer ntote
      common /ERRS  / te,el1,ntote
c
c Local variables
c
      integer i
c
      rewind(15)
      do i=1,ntote
        write(15,'(f6.2,f9.6)')te(i),el1(i)
      enddo
      return
      end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      real*8 function cflt(wn)
      implicit none
c
c common variables
c
      real*8 cprd(400),sdvp(400),wvnp(400)
      integer ntotp
      common /PCOH  / wvnp,cprd,sdvp,ntotp
c
c Dummy arguments
c
      real*8 wn
c
c Local variables
c
      integer i
c
      if(wn.lt.wvnp(1))then
        cflt=1d0
      elseif(wn.ge.wvnp(ntotp))then
        cflt=0d0
      else
        do i=1,ntotp-1
          if(wn.ge.wvnp(i).and.wn.lt.wvnp(i+1))then
            cflt=cprd(i)+(cprd(i+1)-cprd(i))*(wn-wvnp(i))
     &             /(wvnp(i+1)-wvnp(i))
          endif
        enddo
      endif
      if(cflt.gt.1d0)cflt=1d0
      return
      end
