cccccccc program: outkey.f ccccc version: 31/Aug/2001 cccccccccccccccccccccccc
c Determines best-fit and 95% confidence bounds on te estimates from grid
c   searched coherence analysis results (for compilation from a multiple 
c   directory structure).
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c  Modified by Gareth Armstrong,Dept. Earth Sciences,Uni. Oxford,
c  on 17/2/99 to use the Salford 
c  ftn77 compiler call to COMMand_LINE to read in command line arguments 
c  similar to the f77 compiler call to getarg when being used on the PC
c  Comment or uncomment relevant calls as required.
c  Changed Units numbers to be above 12 
c  Doesn't seem to need to be array size adjustable 
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      implicit none
c
c common variables
c
      real*8 el1(100),elsk(100),erh(100),te(100),tesk(100)
      integer ntote
      common /ERRS  / te,el1,erh,ntote
      common /ERSK  / tesk,elsk
c
c Local variables
c
      real*8 dmult,efac
      character copfile*20,card*40
      real*8 dfloat
      integer i,imn,imx,io
      integer nint
c
      call getarg(1,copfile)
c
c ------------------------------------------------------------------
c  SALFORD FTN77 COMPILER COMMand LINE read SUBROUNTINE call SIMILAR
c     TO F77 call TO getarg but for use on PC
c
c  modified by Gareth Armstrong 3/11/96
c-------------------------------------------------------------------
c
c      call COMMand_LINE(card)
c      read(card,*)copfile
c
      open(13,file=copfile,status='old')
      rewind(13)
c
c*****************************************************
c Efac (factor to determine 95% confidence limits)   *
c     was calculated for 20 independent measurements *
c     of coherence and one parameter (Te).           *
c*****************************************************
      efac=1.42901281596470d0
c
      dmult=2d0**(1d0/12d0)
      do i=1,85
        elsk(i)=0d0
        tesk(i)=dfloat(nint(20d0*dmult**(i-1)))/10d0
      enddo
c
      call input
c
      io=1
      do while(.true.)
        if(elsk(io).eq.0d0)then
          io=io+1
          goto100
        endif
        do i=2,85
          if(elsk(i).lt.elsk(io).and.elsk(i).ne.0d0)io=i
        enddo
        imn=io
        do i=io,1,-1
          if(elsk(i).le.elsk(io)*efac.and.elsk(i).ne.0d0)imn=i
        enddo
        imx=io
        do i=io,85
          if(elsk(i).le.elsk(io)*efac.and.elsk(i).ne.0d0)imx=i
        enddo
        write(*,1015)tesk(io),tesk(imn-1),tesk(imx+1),elsk(io) 
        goto200
100   enddo
c
200   continue
1015  format(f6.2,2f7.2,f8.5)
      end
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine input
      implicit none
c
c common variables
c
      real*8 el1(100),elsk(100),erh(100),te(100),tesk(100)
      integer ntote
      common /ERRS  / te,el1,erh,ntote
      common /ERSK  / tesk,elsk
c
c Local variables
c
      integer i
      real*8 r1,r2
      real*8 dabs
c
      ntote=0
      do while(.true.)
        read(13,*,end=100)r1,r2
        ntote=ntote+1
        te(ntote)=r1
        el1(ntote)=r2
        do i=1,85
          if(dabs(tesk(i)-r1).lt.5d-2)then
            elsk(i)=r2
          endif
        enddo
      enddo
100   return
      end
