ccccc program:  part.f cccccc version: 22 Aug 2001 cccccccccccccccccccccc
c
c  Program to pare and decimate a data subgrid from a master data file.
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c  Modified by Gareth Armstrong,Dept. Earth Sciences,Uni. Oxford,
c  on 17/2/99 to use the Salford 
c  ftn77 compiler call to COMMAND_LINE to read in command line arguments 
c  similar to the f77 compiler call to getarg when being used on the PC
c  Comment or uncomment relevant calls as required.
c  Changed Units numbers to be above 12
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      implicit none
      include 'coheren.inc'
c
c Local variables
c
      real*8 dx,ewtd,mnln,mnlt,mxln,mxlt,nstd,theta,z(nrmax,ncmax)
      real*8 dfloat
      integer i,id,ilat0,ilon0,j,nargs,nc,nc0,nc1,nc2,ndc,nr,
     &        nr0,nr1,nr2
      integer iargc
      character infile1*20,infile2*20,outfile*20,card*50
c
      nargs=iargc()
c
      if(nargs.ne.3)then
        write(*,*)'usage: prog header infile outfile'
        call exit(-1)
      else
        call getarg(1,infile1)
        call getarg(2,infile2)
        call getarg(3,outfile)
      endif
c
c ------------------------------------------------------------------
c  SALFORD FTN77 COMPILER COMMAND LINE read SUBROUNTINE call SIMILAR
c     TO F77 call TO getarg but for use on PC
c
c  modified by Gareth Armstrong 3/11/96
c-------------------------------------------------------------------
c
c      call COMMAND_LINE(card)
c      read(card,*)infile1,infile2,outfile
c
c
      open(unit=13,file=infile1,status='old')
      open(unit=14,file=infile2,form='unformatted',status='unknown')
      open(unit=15,file=outfile,form='unformatted',status='unknown')
c
      read(13,*)nc1,nc2
      read(13,*)nr1,nr2
      read(13,*)ndc
c
      read(14)id,ilon0,ilat0,dx,theta
      write(15)id,ilon0,ilat0,dx*dfloat(ndc),theta
      read(14)nc,nr,ewtd,nstd
      read(14)mnln,mxln,mnlt,mxlt
c
      nc0=(nc2-nc1)/ndc+1
      nr0=(nr2-nr1)/ndc+1
      write(15)nc0,nr0,dx*dfloat((nc0-1)*ndc),dx*dfloat((nr0-1)*ndc)
      write(15)0d0,1d0,0d0,1d0
      do j=1,nr
        read(14)(z(i,j),i=1,nc)
      enddo
      do j=nr1,nr2,ndc
        write(15)(z(i,j),i=nc1,nc2,ndc)
      enddo
      end
