c splitt.f **** version: 21 Jan 2003 *******************************
c Splits gravity and topography signals into ocean and land
c components to facilitate deconvolution using the correct respective
c fluid density. NOTE: Areas with elevation less than zero are
c assumed to be oceanic. If that's not the case, this program will
c need to be customized.
c
c This version has been customized for the western U.S. data set 
c generated 04 Aug 2001.
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c  Modified by Gareth Armstrong, Dept. Earth Sciences, Uni. Oxford,
c  on 17/2/99 
c  Changed Units numbers to be above 12 and made array size adjustable
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      implicit none
      include'coheren.inc'
c
c Local variables
c
      real*8 alatmn,alatmx,alonmn,alonmx,grv(ncmax),lgrv(ncmax),
     &     ltop(ncmax),ogrv(ncmax),otop(ncmax),rl(2),spac,theta,
     &     top(ncmax)
      character filgl*20,filgo*20,filing*20,filint*20,filtl*20,filto*20
      integer i,ident,ilat0,ilon0,j,nc,nr
c
c********************** main program ********************
c
      open(12,file='split.com',status='unknown')
      rewind(12)
      read(12,*)filint
      read(12,*)filing
      read(12,*)filto
      read(12,*)filgo
      read(12,*)filtl
      read(12,*)filgl
c
      open(13,file=filint,form='unformatted',status='old')
      rewind(13)
      open(14,file=filing,form='unformatted',status='old')
      rewind(14)
      open(15,file=filto,form='unformatted',status='unknown')
      rewind(15)
      open(16,file=filgo,form='unformatted',status='unknown')
      rewind(16)
      open(17,file=filtl,form='unformatted',status='unknown')
      rewind(17)
      open(18,file=filgl,form='unformatted',status='unknown')
      rewind(18)
c
      read(13)ident,ilon0,ilat0,spac,theta
      read(13)nc,nr,rl(2),rl(1)
      read(13)alonmn,alonmx,alatmn,alatmx
      write(15)1,ilon0,ilat0,spac,theta
      write(15)nc,nr,rl(2),rl(1)
      write(15)alonmn,alonmx,alatmn,alatmx
      write(17)1,ilon0,ilat0,spac,theta
      write(17)nc,nr,rl(2),rl(1)
      write(17)alonmn,alonmx,alatmn,alatmx
      read(14)ident,ilon0,ilat0,spac,theta
      read(14)nc,nr,rl(2),rl(1)
      read(14)alonmn,alonmx,alatmn,alatmx
      write(16)0,ilon0,ilat0,spac,theta
      write(16)nc,nr,rl(2),rl(1)
      write(16)alonmn,alonmx,alatmn,alatmx
      write(18)0,ilon0,ilat0,spac,theta
      write(18)nc,nr,rl(2),rl(1)
      write(18)alonmn,alonmx,alatmn,alatmx
c
c************************************
c
      do j=1,nr
        read(13)(top(i),i=1,nc)
        read(14)(grv(i),i=1,nc)
        do i=1,nc
          if(top(i).ge.0d0)then
            ltop(i)=top(i)
            lgrv(i)=grv(i)
            otop(i)=0d0
            ogrv(i)=0d0
          else
            ltop(i)=0d0
            lgrv(i)=0d0
            otop(i)=top(i)
            ogrv(i)=grv(i)
          endif
        enddo
        write(15)(otop(i),i=1,nc)
        write(16)(ogrv(i),i=1,nc)
        write(17)(ltop(i),i=1,nc)
        write(18)(lgrv(i),i=1,nc)
      enddo
      end
c
